; View compressed files with packer92 'CPkP' or shrink92 'CPkS'
;
	xdef	_main
	xdef	_comment

	xdef	_ti89
	xdef	_ti92plus

	include "tios.h"
	include "pk92lib.h"
	include "shrnklib.h"

_main:
	bra.s	ok_main
hd:	dc.w	0
ok_main:
	; Get handle...
	move.w	hd(pc),d0
	bne.s	\hd_found
		; Get adress of the string
		move.l	tios::top_estack,a0
		subq.l	#1,a0		; We don't test the string TAG
		clr.w	-(a7)
		move.l	a0,-(a7)
		jsr	tios::SymFindPtr
		addq.l	#6,a7
		; Found ?
		move.l	a0,d0
		beq	notfound
		; Get handle
		move.w	SYM_ENTRY.hVal(a0),d0
\hd_found:
	clr.w	hd

	; Get adress of the file
	tios::DEREF	d0,a0
	; Skip the size of the string
	addq.l	#2,a0

	lea	extracting(pc),a2
	bsr.s	show_help

	move.w	#$700,d0
	trap	#1
	
	; Cmp signature
	move.l	(a0)+,d0
	cmp.l	#'CPkP',d0
	bne.s	test_shk92

		; Open archive with packer92
		moveq	#0,d0
		jsr	pk92lib::Extract
		tst.b	d0
		bne.s	illegal_prgm
		move.l	a1,a0
		bra.s	run
test_shk92
	cmp.l	#'CPkS',d0
	bne	test_arch

		; Open archive with Shrink92
		bsr.s	ShkOpen
		tst.w	d0
		beq.s	illegal_prgm
			moveq	#0,d1
			move.l	d1,a0
			bsr.s	ShkExtract
			bsr.s	ShkClose
			move.w	d2,d1
			beq.s	illegal_prgm

	; Run file with handle d1.w & adr: a0.l
run:
	move.w	d1,-(a7)	; Save it to free it later

	; Get adress of the prgm
;	move.l	a0,a5
;	addq.l	#2,a5		; Skip size of the prgm
	; Relocation...
;	moveq	#0,d1
;	move.w	(a0),d1
;	lea	1(a0,d1.l),a0
;	moveq	#0,d0
;\rloop:	
;	move.w	-(a0),d0
;	beq.s	\endr
;		moveq	#0,d1
;		move.w	-(a0),d1
;		add.l	a5,d1
;		move.l	d1,0(a5,d0.l)
;		bra.s	\rloop
;\endr:
	moveq	#0,d1
	move.w	(a0)+,d1
	move.l	a0,a5

	pea	-1(a0,d1.l)
	move.l	a5,-(a7)
	jsr	tios::EX_patch
	addq.l	#8,a7
	
	; Lock it ????????????
	move.w	(a7),d0
	bsr.s	HLock

	moveq	#000,d0
	trap	#1

	; Execution
	jsr	(a5)
	bra.s	Free_stack

	; Affiche un message
show_help:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	a2,-(a7)
	jsr	tios::ST_helpMsg
	addq.l  #4,a7
	movem.l	(a7)+,d0-d7/a0-a6
	rts

	; Libere l'handle alloue

Free:	move.w	d0,-(a7)
Free_stack:
	jsr	tios::HeapFree
	addq.w	#2,a7
	rts
	
illegal_prgm:
	lea	illegal_prgm_str(pc),a2
	bra.s	show_string

notfound:
	lea	pas_trouve_str(pc),a2
show_string:
	bsr.s	show_help
	moveq	#000,d0
	trap	#1
	clr.l	-(a7)
	clr.w	-(a7)
	jsr	tios::GKeyIn
	addq.l	#6,a7
	rts

ShkOpen:	jmp	shrnklib::OpenArchive
ShkExtract:	jmp	shrnklib::Extract
ShkClose:	jmp	shrnklib::CloseArchive

HLock	
	movem.l	d0-d7/a0-a6,-(a7)
	move.w	d0,-(a7)
	jsr	tios::HeapLock
	addq.w	#2,a7
	movem.l	(a7)+,d0-d7/a0-a6
	rts	

test_arch
	cmp.l	#'CPkA',d0
	bne.s	illegal_prgm

	; Plusieurs paquets a recreer.
	; Adr -> a0
	bsr.s	ShkOpen
	move.w	d0,d7
	beq.s	\error

	; Extraction de la table des noms
	moveq	#0,d1
	move.l	d1,a0
	bsr	ShkExtract
	move.l	a0,d0
	beq.s	\error
	move.w	d2,d4
	move.w	d2,d0
	bsr.s	HLock

	move.l	a0,a6

	moveq	#0,d6	
\loop:		bsr.s	find_next
		cmp.b	#-1,-1(a6)
		beq.s	\end
		
		addq.l	#1,d6

		movea.w	#0,a0
		move.w	d6,d1
		move.w	d7,d0
		bsr.s	ShkExtract
		move.l	a0,d0
		beq.s	\loop
		move.w	d2,d5
		
		move.l	a6,-(a7)
		jsr	tios::SymAdd
		addq.l	#4,a7
		tst.l	d0
		beq.s	\next_in_loop

		move.l	d0,-(a7)
		jsr	tios::DerefSym
		addq.l	#4,a7
		
		move.w	d5,tios::SYM_ENTRY.hVal(a0)
		bra.s	\loop
\next_in_loop
		move.w	d5,d0
		bsr	Free
		bra.s	\loop
\end:
\error:
	move.w	d4,d0
	bsr	Free
	
	moveq	#000,d0
	trap	#1

	move.w	d7,d0
	bra	ShkClose
		

find_next:
	addq.l	#1,a6
\next		tst.b	(a6)+
		bne.s	\next
	subq.l	#1,a6
	rts

pas_trouve_str:		dc.b "File not found",0
illegal_prgm_str:	dc.b "Illegal archive",0
extracting:		dc.b "Extracting...",0

_comment:	dc.b "PkSk viewer",0


	end
